#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h> // for open
#include <unistd.h> // for close

#define PASSIZE 43
#define READLEN 29
int pfd;
char *pass;
char *inp;

// These 3 are so 'push ebx' is not in checkPass
void fail(char *buf) {
    puts("Ugh! You kiss your mother with that mouth?");
    read(0, buf, READLEN);
}

int doStrcmp(char *a, char *b) {
    return !strcmp(a, b);
}

// Does the check & overflow
void checkPass() {
    if (doStrcmp(inp, pass)) {
	// cat flag
	lisa();
    } else {
	// 1byte ret-addr overflow
	char buf[24];
	fail(buf);
    }
}

// Funny program to give space betwewen main and checkPass (because relative jump)
void lisa() {
    puts("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
    puts("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
    puts("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!>''''''<!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
    puts("!!!!!!!!!!!!!!!!!!!!!!!!!!!!'''''`             ``'!!!!!!!!!!!!!!!!!!!!!!!!");
    puts("!!!!!!!!!!!!!!!!!!!!!!!!''`          .....         `'!!!!!!!!!!!!!!!!!!!!!");
    puts("!!!!!!!!!!!!!!!!!!!!!'`      .      :::::'            `'!!!!!!!!!!!!!!!!!!");
    puts("!!!!!!!!!!!!!!!!!!!'     .   '     .::::'                `!!!!!!!!!!!!!!!!");
    puts("!!!!!!!!!!!!!!!!!'      :          `````                   `!!!!!!!!!!!!!!");
    puts("!!!!!!!!!!!!!!!!        .,cchcccccc,,.                       `!!!!!!!!!!!!");
    puts("!!!!!!!!!!!!!!!     .-\"?$$$$$$$$$$$$$$c,                      `!!!!!!!!!!!");
    puts("!!!!!!!!!!!!!!    ,ccc$$$$$$$$$$$$$$$$$$$,                     `!!!!!!!!!!");
    puts("!!!!!!!!!!!!!    z$$$$$$$$$$$$$$$$$$$$$$$$;.                    `!!!!!!!!!");
    puts("!!!!!!!!!!!!    <$$$$$$$$$$$$$$$$$$$$$$$$$$:.                    `!!!!!!!!");
    puts("!!!!!!!!!!!     $$$$$$$$$$$$$$$$$$$$$$$$$$$h;:.                   !!!!!!!!");
    puts("!!!!!!!!!!'     $$$$$$$$$$$$$$$$$$$$$$$$$$$$$h;.                   !!!!!!!");
    puts("!!!!!!!!!'     <$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$                   !!!!!!!");
    puts("!!!!!!!!'      `$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$F                   `!!!!!!");
    puts("!!!!!!!!        c$$$$???$$$$$$$P\"\"  \"\"\"??????\"                      !!!!!!");
    puts("!!!!!!!         `\"\" .,.. \"$$$$F    .,zcr                            !!!!!!");
    //puts("!!!!!!!         .  dL    .?$$$   .,cc,      .,z$h.                  !!!!!!");
    printf("\t\t\t\t"); system("/bin/cat ./flag");
    puts("!!!!!!!!        <. $$c= <$d$$$   <$$$$=-=+\"$$$$$$$                  !!!!!!");
    puts("!!!!!!!         d$$$hcccd$$$$$   d$$$hcccd$$$$$$$F                  `!!!!!");
    puts("!!!!!!         ,$$$$$$$$$$$$$$h d$$$$$$$$$$$$$$$$                   `!!!!!");
    puts("!!!!!          `$$$$$$$$$$$$$$$<$$$$$$$$$$$$$$$$'                    !!!!!");
    puts("!!!!!          `$$$$$$$$$$$$$$$$\"$$$$$$$$$$$$$P>                     !!!!!");
    puts("!!!!!           ?$$$$$$$$$$$$??$c`$$$$$$$$$$$?>'                     `!!!!");
    puts("!!!!!           `?$$$$$$I7?\"\"    ,$$$$$$$$$?>>'                       !!!!");
    puts("!!!!!.           <<?$$$$$$c.    ,d$$?$$$$$F>>''                       `!!!");
    puts("!!!!!!            <i?$P\"??$$r--\"?\"\"  ,$$$$h;>''                       `!!!");
    puts("!!!!!!             $$$hccccccccc= cc$$$$$$$>>'                         !!!");
    puts("!!!!!              `?$$$$$$F\"\"\"\"  `\"$$$$$>>>''                         `!!");
    puts("!!!!!                \"?$$$$$cccccc$$$$??>>>>'                           !!");
    puts("!!!!>                  \"$$$$$$$$$$$$$F>>>>''                            `!");
    puts("!!!!!                    \"$$$$$$$$???>'''                                !");
    puts("!!!!!>                     `\"\"\"\"\"                                        `");
    puts("!!!!!!;                       .                                          `");
    puts("!!!!!!!                       ?h.");
    puts("!!!!!!!!                       $$c,");
    puts("!!!!!!!!>                      ?$$$h.              .,c");
    puts("!!!!!!!!!                       $$$$$$$$$hc,.,,cc$$$$$");
    puts("!!!!!!!!!                  .,zcc$$$$$$$$$$$$$$$$$$$$$$");
    puts("!!!!!!!!!               .z$$$$$$$$$$$$$$$$$$$$$$$$$$$$");
    puts("!!!!!!!!!             ,d$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$          .");
    puts("!!!!!!!!!           ,d$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$         !!");
    puts("!!!!!!!!!         ,d$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$        ,!'");
    puts("!!!!!!!!>        c$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$.       !'");
    puts("!!!!!!''       ,d$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$>       '");
    puts("!!!''         z$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$>");
    puts("!'           ,$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$>             ..");
    puts("            z$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'           ;!!!!''`");
    puts("            $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$F       ,;;!'`'  .''");
    puts("           <$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$>    ,;'`'  ,;");
    puts("           `$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$F   -'   ,;!!'");
    puts("            \"?$$$$$$$$$$?$$$$$$$$$$$$$$$$$$$$$$$$$$F     .<!!!'''       <!");
    puts("         !>    \"\"??$$$?C3$$$$$$$$$$$$$$$$$$$$$$$$\"\"     ;!'''          !!!");
    puts("       ;!!!!;,      `\"''\"\"????$$$$$$$$$$$$$$$$\"\"   ,;-''               ',!");
    puts("      ;!!!!<!!!; .                `\"\"\"\"\"\"\"\"\"\"\"    `'                  ' '");
    puts("      !!!! ;!!! ;!!!!>;,;, ..                  ' .                   '  '");
    puts("     !!' ,;!!! ;'`!!!!!!!!;!!!!!;  .        >' .''                 ;");
    puts("    !!' ;!!'!';! !! !!!!!!!!!!!!!  '         -'");
    puts("   <!!  !! `!;! `!' !!!!!!!!!!<!       .");
    puts("   `!  ;!  ;!!! <' <!!!! `!!! <       /");
    puts("  `;   !>  <!! ;'  !!!!'  !!';!     ;'");
    puts("   !   !   !!! !   `!!!  ;!! !      '  '");
    puts("  ;   `!  `!! ,'    !'   ;!'");
    puts("      '   /`! !    <     !! <      '");
    puts("           / ;!        >;! ;>");
    puts("             !'       ; !! '");
    puts("          ' ;!        > ! '");
    puts("            '");
}

int main() {
    setvbuf(stdout, NULL, _IONBF, 20);
    setvbuf(stdin, NULL, _IONBF, 20);

    // buffer that touche retaddr to checkPass
    char buf[48];
    memset(buf, 0, 48);
    pass = malloc(PASSIZE);
    // CTF...
    printf("Here's your share: %p\n", pass);

    // Get input (secure)
    puts("What? The Mona Lisa!\nLook, if you want somethin' from me, I'm gonna need somethin' from you alright...");
    read(0, buf, 48);
    // Because CTF
    // This is a way to pass arguments to checkPass without putting them on the stack
    inp = buf;

    // Password read
    pfd = open("./password", 0);
    read(pfd, pass, PASSIZE); // <-- ret here read(0, pass, passize)

    checkPass();
    return 0;
}
